
import JCAB.IO
import JCAB.String
import JCAB.Data

import Win32

import Data.Bits
import Data.Char
import Data.IORef
import Data.Array.Diff
import qualified Data.HashTable as Hash
import Data.HashTable(HashTable(..), hashInt)
import Control.Monad
import Debug.Trace
import Foreign
import Foreign.C.Types
import Foreign.C.String
import System.IO

import Control.Concurrent




-- Silly function, useful for using in inline-defined looping threads.
loopThread :: IO Bool -> IO ()
loopThread a = a >>= \result -> if result then loopThread a else return ()





-- An implementation of Bob Jenkins' hash function, taken from:
--
--   http://burtleburtle.net/bob/hash/doobs.html
--
-- Original copyright:
--
--   By Bob Jenkins, 1996.  bob_jenkins@burtleburtle.net.  You may use this
--   code any way you wish, private, educational, or commercial.  It's free.
--
--   See http://burtleburtle.net/bob/hash/evahash.html
--   Use for hash table lookup, or anything where one collision in 2^^32 is
--   acceptable.  Do NOT use for cryptographic purposes.
--
bobJenkinsHashFragment :: Int32 -> [Int32] -> Int32
bobJenkinsHashFragment initval k =
    let v@(a, b, c) = (0x9e3779b9, 0x9e3779b9, initval) in -- the golden ratio; an arbitrary value, and the previous hash value

    let (_, _, result) = foldl  (\(a, b, c) (na, nb, nc) -> mix (a+na, b+nb, c+nc))
                                v
                                (zip k)
                                in

    result

    where

    zip (a:b:c:rest) = (a, b, c):zip rest
    zip [a, b]       = [(a, b, 0)]
    zip [a]          = [(a, 0, 0)]
    zip []           = []

    mix (a, b, c) =
        let a1 = (a  - b  - c ) `xor` (c  `shiftR` 13) in
        let b1 = (b  - c  - a1) `xor` (a1 `shiftL`  8) in
        let c1 = (c  - a1 - b1) `xor` (b1 `shiftR` 13) in
        let a2 = (a1 - b1 - c1) `xor` (c1 `shiftR` 12) in
        let b2 = (b1 - c1 - a2) `xor` (a2 `shiftL` 16) in
        let c2 = (c1 - a2 - b2) `xor` (b2 `shiftR`  5) in
        let a3 = (a2 - b2 - c2) `xor` (c2 `shiftR`  3) in
        let b3 = (b2 - c2 - a3) `xor` (a3 `shiftL` 10) in
        let c3 = (c2 - a3 - b3) `xor` (b3 `shiftR` 15) in
        (a3, b3, c3)

bobJenkinsHash :: [Int32] -> Int32
bobJenkinsHash = bobJenkinsHashFragment 0x9e3779b9

int32ArrayHash = bobJenkinsHash











nullDictionaryEntry = ("", "", "", "")

parseDictionaryEntry line =
    let (trad,    rest1, result1) = getTokenUntil ' ' line in
    let (pinyin,  rest2, result2) = getTokenUntil ']' $ skipPast '[' rest1 in
    let (english, rest3, result3) = getTokenUntilLast '/' $ skipPast '/' rest2 in
    if result1 && result2 && result3 then
            (trad, "", pinyin, english)
        else
            nullDictionaryEntry
    where
    getTokenUntil _ [] = ([], [], False)
    getTokenUntil ch (x:rest)
        | ch == x   = ("", rest, True)
        | otherwise = let (s, rest2, result2) = getTokenUntil ch rest in (x:s, rest2, result2)
    getTokenUntilLast _ [] = ([], [], False)
    getTokenUntilLast ch (x:rest)
        | ch == x    =  let (s, rest2, result2) = getTokenUntil ch rest in
                        if result2 then
                                (x:s, rest2, result2)
                            else
                                ("", rest, True)
        | otherwise  = let (s, rest2, result2) = getTokenUntil ch rest in (x:s, rest2, result2)
    skipPast ch [] = []
    skipPast ch (x:rest)
        | ch == x   = rest
        | otherwise = x:skipPast ch rest


{-
    Problem: GHC's Regex only supports extended ASCII. It truncates UNICODE.

parseDictionaryEntry line =
    case matchRegex (mkRegexWithOpts "([^ ]*)[^[]*\\[([^]]*)\\][^/]*/(.*)/[^/]*" False False) line of
        Just (trad:pinyin:english:_) -> (trad, "", pinyin, english)
        otherwise -> nullDictionaryEntry
-}

readDictionary n [] = []
readDictionary n (('#':_):rest) = readDictionary (n+1) rest
readDictionary n (line:rest) =
    let entry = parseDictionaryEntry line in
    if entry /= nullDictionaryEntry then
            entry:readDictionary (n+1) rest
        else
            readDictionary (n+1) rest





refilter :: DiffArray Int (CWString, CWString, CWString, CWString) -> Int -> String -> DiffUArray Int Int -> Int -> IO (DiffUArray Int Int, Int)
refilter dict n s index i =
    if inRange (bounds dict) n then do
            let (ctrad, csimp, cpinyin, cenglish) = dict ! n
            pinyin <- peekCWString cpinyin
            if s == take (length s) pinyin then
                    refilter dict (n+1) s (index // [(i, n)]) (i+1)
                else
                    refilter dict (n+1) s index i
        else
            return (index, i)
















type WMsgProc = HWND -> WPARAM -> LPARAM -> IO LRESULT


type WMsgProc_CREATE = HWND -> IO Bool
wMsgProc_CREATE :: WMsgProc_CREATE -> WMsgProc
wMsgProc_CREATE a hwnd wParam lParam = do
    result <- a hwnd
    if result then
            return 0
        else
            return (-1)
addWMsgProc_CREATE dispatcher = addWMSG dispatcher wM_CREATE . wMsgProc_CREATE


type WMsgProc_SETFOCUS = HWND -> HWND -> IO Bool
wMsgProc_SETFOCUS :: WMsgProc_SETFOCUS -> WMsgProc
wMsgProc_SETFOCUS a hwnd wParam lParam = do
    result <- a hwnd (castToHWND wParam)
    if result then
            return 0
        else
            defWindowProc hwnd wM_SETFOCUS wParam lParam
addWMsgProc_SETFOCUS dispatcher = addWMSG dispatcher wM_SETFOCUS . wMsgProc_SETFOCUS


type WMsgProc_ACTIVATE = HWND -> WindowActivation -> Bool -> HWND -> IO Bool
wMsgProc_ACTIVATE :: WMsgProc_ACTIVATE -> WMsgProc
wMsgProc_ACTIVATE a hwnd wParam lParam = do
    result <- a hwnd (WindowActivation $ loWORD wParam) (hiWORD wParam /= 0) (castToHWND lParam)
    if result then
            return 0
        else
            defWindowProc hwnd wM_ACTIVATE wParam lParam
addWMsgProc_ACTIVATE dispatcher = addWMSG dispatcher wM_ACTIVATE . wMsgProc_ACTIVATE


type WMsgProc_COMMAND = HWND -> CHILDID -> CommandID -> HWND -> IO Bool
wMsgProc_COMMAND :: WMsgProc_COMMAND -> WMsgProc
wMsgProc_COMMAND a hwnd wParam lParam = do
    result <- a hwnd (CHILDID $ loWORD wParam) (CommandID $ hiWORD wParam) (castToHWND lParam)
    if result then
            return 0
        else
            defWindowProc hwnd wM_COMMAND wParam lParam


type WMsgProc_NOTIFY = HWND -> PNMHDR -> IO LRESULT
wMsgProc_NOTIFY :: WMsgProc_NOTIFY -> WMsgProc
wMsgProc_NOTIFY a hwnd wParam lParam = a hwnd (castToPtr lParam)


type WMsgProc_NOTIFY_LVN_GETDISPINFO = HWND -> PNMLVDISPINFO -> IO ()
wMsgProc_NOTIFY_LVN_GETDISPINFO :: WMsgProc_NOTIFY_LVN_GETDISPINFO -> WMsgProc_NOTIFY
wMsgProc_NOTIFY_LVN_GETDISPINFO a hwnd p = a hwnd (castPtr p) >> return 0


type WMsgProc_NOTIFY_NM_CUSTOMDRAW = HWND -> PNMCUSTOMDRAW -> IO LRESULT
wMsgProc_NOTIFY_NM_CUSTOMDRAW :: WMsgProc_NOTIFY_NM_CUSTOMDRAW -> WMsgProc_NOTIFY
wMsgProc_NOTIFY_NM_CUSTOMDRAW a hwnd p = a hwnd (castPtr p)


type WMsgProc_NOTIFY_NMLV_CUSTOMDRAW = HWND -> PNMLVCUSTOMDRAW -> IO LRESULT
wMsgProc_NOTIFY_NMLV_CUSTOMDRAW :: WMsgProc_NOTIFY_NMLV_CUSTOMDRAW -> WMsgProc_NOTIFY
wMsgProc_NOTIFY_NMLV_CUSTOMDRAW a hwnd p = a hwnd (castPtr p)


type WMsgProc_PAINT = HWND -> HDC -> PAINTSTRUCT -> IO Bool
wMsgProc_PAINT :: WMsgProc_PAINT -> WMsgProc
wMsgProc_PAINT a hwnd wParam lParam = do
    result <- withPaint hwnd $ \dc ps -> a hwnd dc ps
    if result then
            return 0
        else
            defWindowProc hwnd wM_PAINT wParam lParam
addWMsgProc_PAINT dispatcher = addWMSG dispatcher wM_PAINT . wMsgProc_PAINT


newtype ResizingType = ResizingType { unResizingType :: WPARAM } deriving (Eq, Ord, Show, Num, Storable)

sIZE_RESTORED       = ResizingType 0
sIZE_MINIMIZED      = ResizingType 1
sIZE_MAXIMIZED      = ResizingType 2
sIZE_MAXSHOW        = ResizingType 3
sIZE_MAXHIDE        = ResizingType 4

type WMsgProc_SIZE = HWND -> ResizingType -> SIZE -> IO Bool
wMsgProc_SIZE :: WMsgProc_SIZE -> WMsgProc
wMsgProc_SIZE a hwnd wParam lParam = do
    let w = fromIntegral (lParam .&. 0xFFFF)
    let h = fromIntegral ((lParam `shiftR` 16) .&. 0xFFFF)
    result <- a hwnd (ResizingType wParam) (SIZE w h)
    if result then
            defWindowProc hwnd wM_SIZE wParam lParam
        else
            return 0
addWMsgProc_SIZE dispatcher = addWMSG dispatcher wM_SIZE . wMsgProc_SIZE





type WMsgProc_HashTable              = HashTable  WMSG                    WMsgProc
type WMsgProc_COMMANDCmdId_HashTable = HashTable (CommandID, CHILDID)     WMsgProc_COMMAND
type WMsgProc_COMMANDCmd_HashTable   = HashTable  CommandID               WMsgProc_COMMAND
type WMsgProc_NOTIFYCodeId_HashTable = HashTable (WNOTIFICATION, CHILDID) WMsgProc_NOTIFY
type WMsgProc_NOTIFYCode_HashTable   = HashTable  WNOTIFICATION           WMsgProc_NOTIFY

data WMSGDispatcher = WMSGDispatcher {
    getMsgHashTable                :: WMsgProc_HashTable,
    getCommandCmdIdHashTable       :: WMsgProc_COMMANDCmdId_HashTable,
    getCommandCmdHashTable         :: WMsgProc_COMMANDCmd_HashTable,
    getNotificationCodeIdHashTable :: WMsgProc_NOTIFYCodeId_HashTable,
    getNotificationCodeHashTable   :: WMsgProc_NOTIFYCode_HashTable}

addWMSG          dispatcher         = Hash.insert (getMsgHashTable                dispatcher)
addCOMMANDCmdId  dispatcher cmd id  = Hash.insert (getCommandCmdIdHashTable       dispatcher) (cmd, id)
addCOMMANDCmd    dispatcher         = Hash.insert (getCommandCmdHashTable         dispatcher)
addNOTIFYCodeId  dispatcher code id = Hash.insert (getNotificationCodeIdHashTable dispatcher) (code, id)
addNOTIFYCode    dispatcher         = Hash.insert (getNotificationCodeHashTable   dispatcher)

makeWMSGDispatcher :: IO WMSGDispatcher
makeWMSGDispatcher = do
    msgHashTable                 <- Hash.new (==) (\msg        -> int32ArrayHash [fromIntegral msg])
    commandCmdIdHashTable        <- Hash.new (==) (\(cmd, id)  -> int32ArrayHash [fromIntegral cmd, fromIntegral id])
    commandCmdHashTable          <- Hash.new (==) (\cmd        -> int32ArrayHash [fromIntegral cmd])
    notificationCodeIdHashTable  <- Hash.new (==) (\(code, id) -> int32ArrayHash [fromIntegral code, fromIntegral id])
    notificationCodeHashTable    <- Hash.new (==) (\code       -> int32ArrayHash [fromIntegral code])

    let dispatcher = WMSGDispatcher {
        getMsgHashTable                = msgHashTable,
        getCommandCmdIdHashTable       = commandCmdIdHashTable,
        getCommandCmdHashTable         = commandCmdHashTable,
        getNotificationCodeIdHashTable = notificationCodeIdHashTable,
        getNotificationCodeHashTable   = notificationCodeHashTable}

    addWMSG dispatcher wM_COMMAND $ wMsgProc_COMMAND $ \hwnd id cmd hwndFrom -> do
        handler <- liftM2 orMaybe (Hash.lookup commandCmdIdHashTable (cmd, id))
                                  (Hash.lookup commandCmdHashTable cmd)
        case handler of
            Just h  -> h hwnd id cmd hwndFrom
            Nothing -> return False

    addWMSG dispatcher wM_NOTIFY $ wMsgProc_NOTIFY $ \hwnd pNMHdr -> do
        childId <- getP pNMHDRidFrom pNMHdr
        code    <- getP pNMHDRcode   pNMHdr
        handler <- liftM2 orMaybe (Hash.lookup notificationCodeIdHashTable (code, childId))
                                  (Hash.lookup notificationCodeHashTable code)
        case handler of
            Just h  -> h hwnd (upCast pNMHdr)
            Nothing -> return 0

    return dispatcher

dispatchedWNDPROC dispatcher hwnd msg wParam lParam = do
    handler <- Hash.lookup (getMsgHashTable dispatcher) msg
    case handler of
        Nothing -> defWindowProc hwnd msg wParam lParam
        Just h  -> h hwnd wParam lParam

makeMainWindowProc :: a -> (a -> WMSGDispatcher -> IO ()) -> IO WNDPROC
makeMainWindowProc context proc = do
    dispatcher <- makeWMSGDispatcher
    proc context dispatcher
    return $ dispatchedWNDPROC dispatcher















data MainWindowData = MainWindowData {
    dict :: DiffArray Int (CWString, CWString, CWString, CWString),
    dictIndex :: DiffUArray Int Int,
    dictIndexSize :: Int,
    lastFocusWindow :: HWND,
    eWindow :: HWND,
    lvWindow :: HWND,
    normalTextColor :: COLORREF,
    editHeight :: Int}

refilterRef wdataRef = do
    wdata <- readIORef wdataRef
    str <- getWindowText $ eWindow wdata
    (newIndex, newIndexSize) <- refilter (dict wdata) 0 str (dictIndex wdata) 0
    writeIORef wdataRef $ wdata { dictIndex=newIndex, dictIndexSize=newIndexSize }
    listView_SetItemCount (lvWindow wdata) (fromIntegral newIndexSize)
    --listView_SetItemState (lvWindow wdata) (-1) 0 LVIS_SELECTED
    invalidateRect (lvWindow wdata) Nothing False


cOL_TRAD    = 0
cOL_SIMP    = 1
cOL_PINYIN  = 2
cOL_ENGLISH = 3

cID_LIST = CHILDID 1
cID_EDIT = CHILDID 2






-- This creates a window procedure will only ever serve one window, so it holds on to its unique data.
mainWindowProc wdataRef dispatcher = do

    addWMsgProc_CREATE dispatcher $ \hwnd -> do
        wdata <- readIORef wdataRef
        eHwnd <- createChildWindow
            wC_EDIT
            ""
            (wS_TABSTOP .|. wS_VISIBLE .|. wS_CHILD .|. eS_LEFT .|. eS_AUTOHSCROLL)
            nullRECT
            hwnd
            cID_EDIT
        lvHwnd <- createChildWindow
            wC_LISTVIEW
            "Button"
            (wS_TABSTOP .|. wS_VISIBLE .|. wS_CHILD .|. lVS_NOSORTHEADER .|. lVS_SINGLESEL .|. lVS_REPORT .|. lVS_OWNERDATA)
            nullRECT
            hwnd
            cID_LIST
        if eHwnd /= nullHWND && lvHwnd /= nullHWND then do
                listView_SetExtendedListViewStyleEx lvHwnd (lVS_EX_FULLROWSELECT .|. lVS_EX_HEADERDRAGDROP .|. lVS_EX_GRIDLINES) (lVS_EX_FULLROWSELECT .|. lVS_EX_HEADERDRAGDROP .|. lVS_EX_GRIDLINES)
                listView_SetInsertColumnWidthText lvHwnd cOL_TRAD    200 "Traditional"
                listView_SetInsertColumnWidthText lvHwnd cOL_SIMP    200 "Simplified"
                listView_SetInsertColumnWidthText lvHwnd cOL_PINYIN  200 "PinYin"
                listView_SetInsertColumnWidthText lvHwnd cOL_ENGLISH 800 "English"
                listView_SetItemCount             lvHwnd $ fromIntegral $ staticLength $ dict wdata
                font <- getWindowFont lvHwnd
                setWindowFont eHwnd font False
                height <- withGetDC eHwnd $ \dc ->
                    withSelectFont dc font $ do
                        size <- getTextExtentPoint32 dc "0"
                        style <- getWindowStyle eHwnd
                        let rect = adjustWindowRectEx (makeRECTSize size) style False
                        case rect of
                            Nothing -> return 0
                            Just r -> return $ getRECTHeight r
                case height of
                    Just (Just h) -> writeIORef wdataRef $ wdata {
                        lastFocusWindow = eHwnd,
                        eWindow         = eHwnd,
                        lvWindow        = lvHwnd,
                        editHeight      = fromIntegral h}
                    otherwise     -> writeIORef wdataRef $ wdata {
                        lastFocusWindow = eHwnd,
                        eWindow         = eHwnd,
                        lvWindow        = lvHwnd}
                refilterRef wdataRef
                return True
            else
                return False

    addWMsgProc_PAINT dispatcher $ \hwnd dc ps -> do
        return True

    addWMsgProc_SIZE dispatcher $ \hwnd rtype size -> do
        let rect = makeRECTSize size
        wdata <- readIORef wdataRef
        let h = fromIntegral $ editHeight wdata
        setWindowPos (eWindow wdata) nullHWND (setRECTBottom rect h) (sWP_NOZORDER .|. sWP_NOACTIVATE)
        setWindowPos (lvWindow wdata) nullHWND (setRECTTop rect h) (sWP_NOZORDER .|. sWP_NOACTIVATE)
        return False

    addWMsgProc_SETFOCUS dispatcher $ \hwnd otherHwnd -> do
        wdata <- readIORef wdataRef
        let fwnd = lastFocusWindow wdata
        when_ (fwnd /= nullHWND) $ do
            setFocus fwnd
        return True

    addWMsgProc_ACTIVATE dispatcher $ \hwnd activation minimized otherHwnd -> do
        when_ (activation == wA_INACTIVE) $ do
            wdata <- readIORef wdataRef
            fwnd <- getFocus
            writeIORef wdataRef $ wdata { lastFocusWindow = fwnd }
        return False

    addWMSG dispatcher wM_NOTIFYFORMAT $ \_ _ _ -> return nFR_UNICODE
    addWMSG dispatcher wM_CLOSE        $ \_ _ _ -> postQuitMessage 0 >> return 1

    addCOMMANDCmdId dispatcher eN_CHANGE cID_EDIT $ \hwnd id cmd hwndFrom -> do
        refilterRef wdataRef
        return True

    addNOTIFYCodeId dispatcher lVN_GETDISPINFO cID_LIST $ wMsgProc_NOTIFY_LVN_GETDISPINFO $ \hwnd p -> do
        wdata <- readIORef wdataRef
        i <- getP pLVITEMiItem p
        when_ ((i >= 0) && (i < (fromIntegral $ dictIndexSize wdata))) $ do
            mask <- getP pLVITEMmask p
            when_ ((mask .&. lVIF_TEXT) /= LVIF 0) $ do
                let (trad, simp, pinyin, english) = dict wdata ! (dictIndex wdata ! fromIntegral i)
                col <- getP pLVITEMiSubItem p
                setP pLVITEMpszText p $ case col of
                    _| col == cOL_TRAD    -> trad
                    _| col == cOL_SIMP    -> simp
                    _| col == cOL_PINYIN  -> pinyin
                    _| col == cOL_ENGLISH -> english
            when_ ((mask .&. lVIF_IMAGE) /= LVIF 0) $ do
                setP pLVITEMiImage p (-1)
            when_ ((mask .&. lVIF_STATE) /= LVIF 0) $ do
                setP pLVITEMstate p 0

    addNOTIFYCodeId dispatcher nM_CUSTOMDRAW cID_LIST $ wMsgProc_NOTIFY_NMLV_CUSTOMDRAW $ \hwnd p -> do
        wdata <- readIORef wdataRef
        drawStage <- getP pNMCUSTOMDRAWdwDrawStage p
        case drawStage of

            _| drawStage == cDDS_PREPAINT -> do
                return cDRF_NOTIFYITEMDRAW

            _| drawStage == cDDS_ITEMPREPAINT -> do
                clrText <- getP pNMLVCUSTOMDRAWclrText p
                writeIORef wdataRef $ wdata { normalTextColor = clrText }
                return cDRF_NOTIFYSUBITEMDRAW

            _| drawStage == cDDS_SUBITEMPREPAINT -> do
                itemSpec <- getP pNMCUSTOMDRAWdwItemSpec p
                subItem  <- getP pNMLVCUSTOMDRAWiSubItem p
                if subItem == cOL_PINYIN && itemSpec < (fromIntegral $ dictIndexSize wdata) then do
                        let (ctrad, csimp, cpinyin, cenglish) = dict wdata ! (dictIndex wdata ! fromIntegral itemSpec)
                        pinyin <- peekCWString cpinyin
                        if pinyin == "" || head pinyin == 'a' then
                                setP pNMLVCUSTOMDRAWclrText p $ rgb 0x80 0 0x80
                            else
                                setP pNMLVCUSTOMDRAWclrText p $ normalTextColor wdata
                    else
                        setP pNMLVCUSTOMDRAWclrText p $ normalTextColor wdata
                return cDRF_DODEFAULT

            otherwise -> do
                return cDRF_DODEFAULT



main =
    withCoInitialize cOINIT_APARTMENTTHREADED $ do
        initCommonControls iCC_WIN95_CLASSES
        initGUI

        s <- readBinaryFile "cedict.u"
        t0 <- getTickCount
        let dict = readDictionary 1 $ lines $ fileToUNICODE s
        putStrLn $ "Dictionary size: " ++ show (length dict)
        t1 <- getTickCount
        putStrLn $ "Dictionary loaded in: " ++ show (t1 - t0)

        cdict <- forEachM dict $ \(trad, simp, pinyin, english) -> do
            ctrad    <- newCWString trad
            csimp    <- newCWString simp
            cpinyin  <- newCWString pinyin
            cenglish <- newCWString english
            return (ctrad, csimp, cpinyin, cenglish)

        let dictSize = length dict
        let mdict = listArray (0, dictSize - 1) cdict
        let mindex = listArray (0, dictSize - 1) [0..]

        hInst <- getModuleHandle ""
        arrowCursor <- loadSysCursor iDC_ARROW
        wdata <- newIORef MainWindowData {
            dict            = mdict,
            dictIndex       = mindex,
            dictIndexSize   = dictSize,
            lastFocusWindow = nullHWND,
            eWindow         = nullHWND,
            lvWindow        = nullHWND,
            normalTextColor = rgb 0 0xFF 0,
            editHeight      = 0}

        wndProc <- makeMainWindowProc wdata mainWindowProc

        -- This tests how well concurrent Haskell threads work with Win32 wait functions.
        -- (that's not very well, unfortunately)
        forkIO $ loopThread $ do
            threadDelay 10000 -- microseconds
            putStr "@"
            hFlush stdout
            return True -- Loop again.

        withCreateUniqueWindow
                "MainWindow" cS_DEFAULT
                "Window"
                wndProc
                (wS_OVERLAPPEDWINDOW)
                rectDefault
                nullHWND
                nullHMENU
                nullHICON
                nullHICON
                arrowCursor
                hBRUSH_WINDOW
                hInst
            $ \hwnd -> do
                showWindow hwnd sW_NORMAL --nShowCmd
                messagePumpLoopDlg hwnd
