module JCAB.IO (
    when_,
    fromIO,
    hCopy,
    readBinaryFile
) where

import Foreign.Marshal.Alloc
import System.IO

when_ :: Monad m => Bool -> m a -> m ()
when_ c a = if c then a >> return () else return ()

fromIO f io = io >>= \x -> return (f x)

hCopy hi ho size = allocaBytes msize $ \buf -> copyLoop buf (fromEnum size)
    where
        msize = min (fromEnum size) 65536

        copyLoop _ 0 = return ()
        copyLoop buf size = do
            let csize = min size msize
            hGetBuf hi buf csize
            hPutBuf ho buf csize
            copyLoop buf (size-csize)

readBinaryFile fname = openBinaryFile fname ReadMode >>= hGetContents
