module JCAB.Regex (
	mkRegexNocase,
	mkRegexList, mkRegexNocaseList,
	matchRegexList, matchRegexListAll,
) where

import Text.Regex

mkRegexNocase r = mkRegexWithOpts r False False


mkRegexList :: [(String, a)] -> [(Regex, a)]
mkRegexList = map (\(r, a) -> (mkRegex r, a))

mkRegexNocaseList :: [(String, a)] -> [(Regex, a)]
mkRegexNocaseList = map (\(r, a) -> (mkRegexNocase r, a))

matchRegexList :: a -> [(Regex, [String] -> a)] -> String -> a
matchRegexList def list s = matchRegexList_ list
	where
	matchRegexList_ [] = def
	matchRegexList_ ((regexp, a):rest) =
		case matchRegex regexp s of
			Just args -> a args
			Nothing -> matchRegexList_ rest

matchRegexListAll :: a -> [(Regex, (String, String, String, [String]) -> a)] -> String -> a
matchRegexListAll def list s = matchRegexListAll_ list
	where
	matchRegexListAll_ [] = def
	matchRegexListAll_ ((regexp, a):rest) =
		case matchRegexAll regexp s of
			Just args -> a args
			Nothing -> matchRegexListAll_ rest
