module Win32.COM where

import Win32.System

import Data.Bits
import Data.Typeable
import Foreign.Ptr
import Foreign.Storable




-- Enumeration types

newtype COINIT       = COINIT       { unCOINIT       :: DWORD     } deriving (Eq, Ord, Show, Enum, Num, Real, Integral, Bits, Storable, Typeable)

cOINIT_MULTITHREADED     = COINIT 0x0
cOINIT_APARTMENTTHREADED = COINIT 0x2
cOINIT_DISABLE_OLE1DDE   = COINIT 0x4
cOINIT_SPEED_OVER_MEMORY = COINIT 0x8

withCoInitialize :: COINIT -> IO a -> IO a

withCoInitialize coinit action = do
    result <- c_CoInitializeEx nullPtr coinit
    if hr_SUCCEEDED result then do
            result <- action
            c_CoUninitialize
            return result
        else
            return undefined

foreign import stdcall unsafe "Windows.h CoInitializeEx" c_CoInitializeEx :: PVOID -> COINIT -> IO HRESULT
foreign import stdcall unsafe "Windows.h CoUninitialize" c_CoUninitialize :: IO ()
