module Win32.GDI.Constants where

import Win32.GDI.Types
import Win32.GDI.Foreign

import Win32.System.Types




-- Colors

cOLOR_SCROLLBAR               = COLORTYPE  0
cOLOR_BACKGROUND              = COLORTYPE  1
cOLOR_ACTIVECAPTION           = COLORTYPE  2
cOLOR_INACTIVECAPTION         = COLORTYPE  3
cOLOR_MENU                    = COLORTYPE  4
cOLOR_WINDOW                  = COLORTYPE  5
cOLOR_WINDOWFRAME             = COLORTYPE  6
cOLOR_MENUTEXT                = COLORTYPE  7
cOLOR_WINDOWTEXT              = COLORTYPE  8
cOLOR_CAPTIONTEXT             = COLORTYPE  9
cOLOR_ACTIVEBORDER            = COLORTYPE 10
cOLOR_INACTIVEBORDER          = COLORTYPE 11
cOLOR_APPWORKSPACE            = COLORTYPE 12
cOLOR_HIGHLIGHT               = COLORTYPE 13
cOLOR_HIGHLIGHTTEXT           = COLORTYPE 14
cOLOR_BTNFACE                 = COLORTYPE 15
cOLOR_BTNSHADOW               = COLORTYPE 16
cOLOR_GRAYTEXT                = COLORTYPE 17
cOLOR_BTNTEXT                 = COLORTYPE 18
cOLOR_INACTIVECAPTIONTEXT     = COLORTYPE 19
cOLOR_BTNHIGHLIGHT            = COLORTYPE 20
cOLOR_3DDKSHADOW              = COLORTYPE 21
cOLOR_3DLIGHT                 = COLORTYPE 22
cOLOR_INFOTEXT                = COLORTYPE 23
cOLOR_INFOBK                  = COLORTYPE 24
cOLOR_HOTLIGHT                = COLORTYPE 26
cOLOR_GRADIENTACTIVECAPTION   = COLORTYPE 27
cOLOR_GRADIENTINACTIVECAPTION = COLORTYPE 28
cOLOR_MENUHILIGHT             = COLORTYPE 29
cOLOR_MENUBAR                 = COLORTYPE 30

-- Brushes

wHITE_BRUSH  = STOCK_BRUSH  0
lTGRAY_BRUSH = STOCK_BRUSH  1
gRAY_BRUSH   = STOCK_BRUSH  2
dKGRAY_BRUSH = STOCK_BRUSH  3
bLACK_BRUSH  = STOCK_BRUSH  4
nULL_BRUSH   = STOCK_BRUSH  5
dC_BRUSH     = STOCK_BRUSH 18
hOLLOW_BRUSH = nULL_BRUSH

hBRUSH_SCROLLBAR               = getSysColorBrush cOLOR_SCROLLBAR
hBRUSH_BACKGROUND              = getSysColorBrush cOLOR_BACKGROUND
hBRUSH_ACTIVECAPTION           = getSysColorBrush cOLOR_ACTIVECAPTION
hBRUSH_INACTIVECAPTION         = getSysColorBrush cOLOR_INACTIVECAPTION
hBRUSH_MENU                    = getSysColorBrush cOLOR_MENU
hBRUSH_WINDOW                  = getSysColorBrush cOLOR_WINDOW
hBRUSH_WINDOWFRAME             = getSysColorBrush cOLOR_WINDOWFRAME
hBRUSH_MENUTEXT                = getSysColorBrush cOLOR_MENUTEXT
hBRUSH_WINDOWTEXT              = getSysColorBrush cOLOR_WINDOWTEXT
hBRUSH_CAPTIONTEXT             = getSysColorBrush cOLOR_CAPTIONTEXT
hBRUSH_ACTIVEBORDER            = getSysColorBrush cOLOR_ACTIVEBORDER
hBRUSH_INACTIVEBORDER          = getSysColorBrush cOLOR_INACTIVEBORDER
hBRUSH_APPWORKSPACE            = getSysColorBrush cOLOR_APPWORKSPACE
hBRUSH_HIGHLIGHT               = getSysColorBrush cOLOR_HIGHLIGHT
hBRUSH_HIGHLIGHTTEXT           = getSysColorBrush cOLOR_HIGHLIGHTTEXT
hBRUSH_BTNFACE                 = getSysColorBrush cOLOR_BTNFACE
hBRUSH_BTNSHADOW               = getSysColorBrush cOLOR_BTNSHADOW
hBRUSH_GRAYTEXT                = getSysColorBrush cOLOR_GRAYTEXT
hBRUSH_BTNTEXT                 = getSysColorBrush cOLOR_BTNTEXT
hBRUSH_INACTIVECAPTIONTEXT     = getSysColorBrush cOLOR_INACTIVECAPTIONTEXT
hBRUSH_BTNHIGHLIGHT            = getSysColorBrush cOLOR_BTNHIGHLIGHT
hBRUSH_3DDKSHADOW              = getSysColorBrush cOLOR_3DDKSHADOW
hBRUSH_3DLIGHT                 = getSysColorBrush cOLOR_3DLIGHT
hBRUSH_INFOTEXT                = getSysColorBrush cOLOR_INFOTEXT
hBRUSH_INFOBK                  = getSysColorBrush cOLOR_INFOBK
hBRUSH_HOTLIGHT                = getSysColorBrush cOLOR_HOTLIGHT
hBRUSH_GRADIENTACTIVECAPTION   = getSysColorBrush cOLOR_GRADIENTACTIVECAPTION
hBRUSH_GRADIENTINACTIVECAPTION = getSysColorBrush cOLOR_GRADIENTINACTIVECAPTION
hBRUSH_MENUHILIGHT             = getSysColorBrush cOLOR_MENUHILIGHT
hBRUSH_MENUBAR                 = getSysColorBrush cOLOR_MENUBAR

hBRUSH_WHITE  = getStockBrush wHITE_BRUSH
hBRUSH_LTGRAY = getStockBrush lTGRAY_BRUSH
hBRUSH_GRAY   = getStockBrush gRAY_BRUSH
hBRUSH_DKGRAY = getStockBrush dKGRAY_BRUSH
hBRUSH_BLACK  = getStockBrush bLACK_BRUSH
hBRUSH_NULL   = getStockBrush nULL_BRUSH
hBRUSH_DC     = getStockBrush dC_BRUSH
hBRUSH_HOLLOW = getStockBrush hOLLOW_BRUSH

-- Pens

wHITE_PEN = STOCK_PEN  6
bLACK_PEN = STOCK_PEN  7
nULL_PEN  = STOCK_PEN  8
dC_PEN    = STOCK_PEN 19

hPEN_WHITE = getStockPen wHITE_PEN
hPEN_BLACK = getStockPen bLACK_PEN
hPEN_NULL  = getStockPen nULL_PEN
hPEN_DC    = getStockPen dC_PEN

pS_SOLID            = PENSTYLE 0x00000000
pS_DASH             = PENSTYLE 0x00000001       -- -------
pS_DOT              = PENSTYLE 0x00000002       -- .......
pS_DASHDOT          = PENSTYLE 0x00000003       -- _._._._
pS_DASHDOTDOT       = PENSTYLE 0x00000004       -- _.._.._
pS_NULL             = PENSTYLE 0x00000005
pS_INSIDEFRAME      = PENSTYLE 0x00000006
pS_USERSTYLE        = PENSTYLE 0x00000007
pS_ALTERNATE        = PENSTYLE 0x00000008
pS_STYLE_MASK       = PENSTYLE 0x0000000F

pS_ENDCAP_ROUND     = PENSTYLE 0x00000000
pS_ENDCAP_SQUARE    = PENSTYLE 0x00000100
pS_ENDCAP_FLAT      = PENSTYLE 0x00000200
pS_ENDCAP_MASK      = PENSTYLE 0x00000F00

pS_JOIN_ROUND       = PENSTYLE 0x00000000
pS_JOIN_BEVEL       = PENSTYLE 0x00001000
pS_JOIN_MITER       = PENSTYLE 0x00002000
pS_JOIN_MASK        = PENSTYLE 0x0000F000

pS_COSMETIC         = PENSTYLE 0x00000000
pS_GEOMETRIC        = PENSTYLE 0x00010000
pS_TYPE_MASK        = PENSTYLE 0x000F0000

-- Fonts

oEM_FIXED_FONT      = STOCK_FONT 10
aNSI_FIXED_FONT     = STOCK_FONT 11
aNSI_VAR_FONT       = STOCK_FONT 12
sYSTEM_FONT         = STOCK_FONT 13
dEVICE_DEFAULT_FONT = STOCK_FONT 14
sYSTEM_FIXED_FONT   = STOCK_FONT 16
dEFAULT_GUI_FONT    = STOCK_FONT 17

hFONT_OEM_FIXED      = getStockFont oEM_FIXED_FONT
hFONT_ANSI_FIXED     = getStockFont aNSI_FIXED_FONT
hFONT_ANSI_VAR       = getStockFont aNSI_VAR_FONT
hFONT_SYSTEM         = getStockFont sYSTEM_FONT
hFONT_DEVICE_DEFAULT = getStockFont dEVICE_DEFAULT_FONT
hFONT_SYSTEM_FIXED   = getStockFont sYSTEM_FIXED_FONT
hFONT_DEFAULT_GUI    = getStockFont dEFAULT_GUI_FONT
