module Win32.GDI.Foreign where

import Win32.GDI.Types

import Win32.System.Types

import Foreign.Ptr
import Foreign.Storable
import System.IO.Unsafe




getSysColorBrush = unsafePerformIO . c_GetSysColorBrush
getStockBrush    = unsafePerformIO . c_GetStockBrush

getStockPen = unsafePerformIO . c_GetStockPen

getStockFont = unsafePerformIO . c_GetStockFont




foreign import stdcall unsafe "Windows.h GetStockObject"   c_GetStockBrush    :: STOCK_BRUSH -> IO HBRUSH
foreign import stdcall unsafe "Windows.h GetStockObject"   c_GetStockPen      :: STOCK_PEN -> IO HPEN
foreign import stdcall unsafe "Windows.h GetStockObject"   c_GetStockFont     :: STOCK_FONT -> IO HFONT
foreign import stdcall unsafe "Windows.h GetSysColorBrush" c_GetSysColorBrush :: COLORTYPE -> IO HBRUSH
foreign import stdcall unsafe "Windows.h CreatePen"        c_CreatePen        :: PENSTYLE -> INT -> COLORREF -> IO HPEN

foreign import stdcall unsafe "Windows.h DeleteObject" c_DeleteBrush :: HBRUSH -> IO BOOL
foreign import stdcall unsafe "Windows.h DeleteObject" c_DeletePen   :: HPEN   -> IO BOOL
foreign import stdcall unsafe "Windows.h DeleteObject" c_DeleteFont  :: HFONT  -> IO BOOL

foreign import stdcall unsafe "Windows.h SelectObject"    c_SelectBrush     :: HDC -> HBRUSH -> IO HBRUSH
foreign import stdcall unsafe "Windows.h SelectObject"    c_SelectPen       :: HDC -> HPEN -> IO HPEN
foreign import stdcall unsafe "Windows.h SelectObject"    c_SelectFont      :: HDC -> HFONT -> IO HFONT
foreign import stdcall unsafe "Windows.h SetDCBrushColor" c_SetDCBrushColor :: HDC -> COLORREF -> IO COLORREF
foreign import stdcall unsafe "Windows.h SetDCPenColor"   c_SetDCPenColor   :: HDC -> COLORREF -> IO COLORREF

foreign import stdcall unsafe "Windows.h GetTextExtentPoint32W" c_GetTextExtentPoint32 :: HDC -> PSTR -> INT -> Ptr SIZE -> IO BOOL

foreign import stdcall unsafe "Windows.h Chord"       c_Chord       :: HDC -> INT -> INT -> INT -> INT -> INT -> INT -> INT -> INT -> IO BOOL
foreign import stdcall unsafe "Windows.h Pie"         c_Pie         :: HDC -> INT -> INT -> INT -> INT -> INT -> INT -> INT -> INT -> IO BOOL
foreign import stdcall unsafe "Windows.h Ellipse"     c_Ellipse     :: HDC -> INT -> INT -> INT -> INT -> IO BOOL
foreign import stdcall unsafe "Windows.h Rectangle"   c_Rectangle   :: HDC -> INT -> INT -> INT -> INT -> IO BOOL
foreign import stdcall unsafe "Windows.h RoundRect"   c_RoundRect   :: HDC -> INT -> INT -> INT -> INT -> INT -> INT -> IO BOOL
foreign import stdcall unsafe "Windows.h FillRect"    c_FillRect    :: HDC -> PRECT -> HBRUSH -> IO BOOL
foreign import stdcall unsafe "Windows.h FrameRect"   c_FrameRect   :: HDC -> PRECT -> HBRUSH -> IO BOOL
foreign import stdcall unsafe "Windows.h InvertRect"  c_InvertRect  :: HDC -> PRECT -> IO BOOL
foreign import stdcall unsafe "Windows.h Polygon"     c_Polygon     :: HDC -> PPOINT -> INT -> IO BOOL
foreign import stdcall unsafe "Windows.h PolyPolygon" c_PolyPolygon :: HDC -> PPOINT -> PINT -> INT -> IO BOOL

foreign import stdcall unsafe "Windows.h TextOutW"              c_TextOut              :: HDC -> INT -> INT -> PSTR -> INT -> IO BOOL
