module Win32.System.Foreign where

import Win32.System.Types

import Foreign.C.Types
import Foreign.C.String



-- Initialization

open fname oflag pmode = withCString fname $ \c_fname -> c_open c_fname oflag pmode


foreign import ccall unsafe "HsBase.h __hscore_open" c_open :: CString -> CInt -> CInt -> IO CInt
foreign import ccall unsafe "HsBase.h dup2" dup2            :: CInt -> CInt -> IO CInt




foreign import stdcall unsafe "Windows.h GetLastError"         c_GetLastError        :: IO DWORD
foreign import stdcall unsafe "Windows.h SetLastError"         c_SetLastError        :: DWORD -> IO ()

foreign import stdcall unsafe "Windows.h GetModuleHandleW"     c_GetModuleHandle     :: PSTR -> IO HINSTANCE

foreign import stdcall unsafe "Windows.h Sleep"                c_Sleep               :: MILLISECONDS -> IO ()
foreign import stdcall unsafe "Windows.h GetTickCount"         c_GetTickCount        :: IO MILLISECONDS

foreign import stdcall unsafe "Windows.h QueryPerformanceCounter"   c_QueryPerformanceCounter   :: PULONGLONG -> IO ()
foreign import stdcall unsafe "Windows.h QueryPerformanceFrequency" c_QueryPerformanceFrequency :: PULONGLONG -> IO ()

foreign import stdcall        "Windows.h MessageBoxW"          c_SystemMessageBox    :: PVOID -> PSTR -> PSTR -> MBTYPE -> IO INT

foreign import stdcall        "Windows.h LoadCursorW" c_LoadCursor   :: HINSTANCE -> PSTR -> IO HCURSOR
