module Win32.Window.Foreign where

import Win32.Window.Types

import Win32.GDI.Types

import Win32.System.Types

import Data.Bits




exstyleFromWSTYLE wstyle = (fromIntegral (((unWSTYLE wstyle) `shiftR` 32) .&. 0xFFFFFFFF))
styleFromWSTYLE   wstyle = (fromIntegral ( (unWSTYLE wstyle)              .&. 0xFFFFFFFF))




foreign import stdcall "Windows.h RegisterClassExW"     c_RegisterClassEx     :: PBYTE -> IO ATOM
foreign import stdcall "Windows.h UnregisterClassW"     c_UnregisterClass     :: PSTR -> HINSTANCE -> IO BOOL

foreign import stdcall "Windows.h CreateWindowExW"      c_CreateWindowEx      :: DWORD -> PSTR -> PSTR -> DWORD -> INT -> INT -> INT -> INT -> HWND -> HMENU -> HINSTANCE -> PVOID -> IO HWND

foreign import stdcall "Windows.h SetWindowTextW"       c_SetWindowText       :: HWND -> PSTR -> IO BOOL
foreign import stdcall "Windows.h GetWindowTextW"       c_GetWindowText       :: HWND -> PSTR -> INT -> IO BOOL
foreign import stdcall "Windows.h GetWindowTextLengthW" c_GetWindowTextLength :: HWND -> IO INT
foreign import stdcall "Windows.h GetClientRect"        c_GetClientRect       :: HWND -> PRECT -> IO BOOL

foreign import stdcall "Windows.h InvalidateRect"       c_InvalidateRect      :: HWND -> PRECT -> BOOL -> IO BOOL
foreign import stdcall "Windows.h DestroyWindow"        c_DestroyWindow       :: HWND -> IO BOOL
foreign import stdcall "Windows.h IsWindow"             c_IsWindow            :: HWND -> IO BOOL
foreign import stdcall "Windows.h ShowWindow"           c_ShowWindow          :: HWND -> SW -> IO BOOL
foreign import stdcall "Windows.h SetWindowPos"         c_SetWindowPos        :: HWND -> HWND -> INT -> INT -> INT -> INT -> SWP -> IO BOOL
foreign import stdcall "Windows.h GetFocus"             c_GetFocus            :: IO HWND
foreign import stdcall "Windows.h SetFocus"             c_SetFocus            :: HWND -> IO HWND
foreign import stdcall "Windows.h GetDC"                c_GetDC               :: HWND -> IO HDC
foreign import stdcall "Windows.h ReleaseDC"            c_ReleaseDC           :: HWND -> HDC -> IO BOOL

foreign import stdcall unsafe "Windows.h GetWindowLongW" c_GetWindowDWORD   :: HWND -> GWL -> IO DWORD
foreign import stdcall unsafe "Windows.h SetWindowLongW" c_SetWindowDWORD   :: HWND -> GWL -> DWORD -> IO DWORD

foreign import stdcall "Windows.h SendMessageW"         c_SendMessage         :: HWND -> WMSG -> WPARAM -> LPARAM -> IO LRESULT
foreign import stdcall "Windows.h PostMessageW"         c_PostMessage         :: HWND -> WMSG -> WPARAM -> LPARAM -> IO BOOL

foreign import stdcall unsafe "Windows.h AdjustWindowRectEx" c_AdjustWindowRectEx :: PRECT -> DWORD -> BOOL -> DWORD -> IO BOOL

foreign import stdcall        "Windows.h MessageBoxW"          c_MessageBox          :: HWND -> PSTR -> PSTR -> MBTYPE -> IO INT
